---
title: Using the WebAssembly JavaScript API
slug: WebAssembly/Using_the_JavaScript_API
tags:
  - API
  - DevTools
  - JavaScript
  - WebAssembly
  - compile
  - instantiate
  - memory
  - table
---
<div>{{WebAssemblySidebar}}</div>

<p class="summary">If you have already <a href="/en-US/docs/WebAssembly/C_to_wasm">compiled a module from another language using tools like Emscripten</a>, or <a href="/en-US/docs/WebAssembly/Loading_and_running">loaded and run the code yourself</a>, the next step is to learn more about using the other features of the WebAssembly JavaScript API. This article teaches you what you’ll need to know.</p>

<div class="note">
<p><strong>Note</strong>: If you are unfamiliar with the basic concepts mentioned in this article and need more explanation, read <a href="/en-US/docs/WebAssembly/Concepts">WebAssembly concepts</a> first, then come back.</p>
</div>

<h2 id="Some_simple_examples">Some simple examples</h2>

<p>Let’s run through some examples that explain how to use the WebAssembly JavaScript API, and how to use it to load a wasm module in a web page.</p>

<div class="note">
<p><strong>Note</strong>: You can find the sample code in our <a href="https://github.com/mdn/webassembly-examples">webassembly-examples</a> GitHub repo.</p>
</div>

<h3 id="Preparing_the_example">Preparing the example</h3>

<ol>
 <li>First we need a wasm module! Grab our <a href="https://github.com/mdn/webassembly-examples/raw/master/js-api-examples/simple.wasm">simple.wasm</a> file and save a copy in a new directory on your local machine.</li>
 <li>Next, let’s create a simple HTML file called <code>index.html</code> in the same directory as your wasm file (can use our <a href="https://github.com/mdn/webassembly-examples/blob/master/template/template.html">simple template</a> if you haven’t got one easily available).</li>
 <li>Now, to help us understand what is going on here, let’s look at the text representation of our wasm module (which we also meet in <a href="/en-US/docs/WebAssembly/Text_format_to_wasm#A_first_look_at_the_text_format">Converting WebAssembly format to wasm</a>):
  <pre class="notranslate">(module
  (func $i (import "imports" "imported_func") (param i32))
  (func (export "exported_func")
    i32.const 42
    call $i))</pre>
 </li>
 <li>In the second line, you will see that the import has a two-level namespace — the internal function <code>$i</code> is imported from <code>imports.imported_func</code>. We need to reflect this two-level namespace in JavaScript when writing the object to be imported into the wasm module. Create a <code>&lt;script&gt;&lt;/script&gt;</code> element in your HTML file, and add the following code to it:
  <pre class="brush: js notranslate">var importObject = {
  imports: { imported_func: arg =&gt; console.log(arg) }
};</pre>
 </li>
</ol>

<h3 id="Streaming_the_WebAssembly_module">Streaming the WebAssembly module</h3>

<p>New in Firefox 58 is the ability to compile and instantiate WebAssembly modules directly from underlying sources. This is achieved using the {{jsxref("WebAssembly.compileStreaming()")}} and {{jsxref("WebAssembly.instantiateStreaming()")}} methods. These methods are easier than their non-streaming counterparts, because they can turn the byte code directly into <code>Module</code>/<code>Instance</code> instances, cutting out the need to separately put the {{domxref("Response")}} into an {{domxref("ArrayBuffer")}}.</p>

<p>This example (see our <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/instantiate-streaming.html">instantiate-streaming.html</a> demo on GitHub, and <a href="https://mdn.github.io/webassembly-examples/js-api-examples/instantiate-streaming.html">view it live</a> also) shows how to use <code>instantiateStreaming()</code> to fetch a wasm module, import a JavaScript function into it, compile and instantiate it, and access its exported function — all in one step.</p>

<p>Add the following to your script, below the first block:</p>

<pre class="brush: js notranslate">WebAssembly.instantiateStreaming(fetch('simple.wasm'), importObject)
.then(obj =&gt; obj.instance.exports.exported_func());</pre>

<p>The net result of this is that we call our exported WebAssembly function <code>exported_func</code>, which in turn calls our imported JavaScript function <code>imported_func</code>, which logs the value provided inside the WebAssembly instance (42) to the console. If you save your example code now and load it a browser that supports WebAssembly, you’ll see this in action!</p>

<div class="note">
<p><strong>Note</strong>: This is a convoluted, longwinded example that achieves very little, but it does serve to illustrate what is possible — using WebAssembly code alongside JavaScript in your web applications. As we’ve said elsewhere, WebAssembly doesn’t aim to replace JavaScript; the two instead can work together, drawing on each other’s strengths.</p>
</div>

<h3 id="Loading_our_wasm_module_without_streaming">Loading our wasm module without streaming</h3>

<p>If you can't or don't want to use the streaming methods as described above, you can use the non-streaming methods {{jsxref("WebAssembly.compile")}} / {{jsxref("WebAssembly.instantiate")}} instead.</p>

<p>These methods don't directly access the byte code, so require an extra step to turn the response into an {{domxref("ArrayBuffer")}} before compiling/instantiating the wasm module.</p>

<p>The equivalent code would look like this:</p>

<pre class="brush: js notranslate">fetch('simple.wasm').then(response =&gt;
  response.arrayBuffer()
).then(bytes =&gt;
  WebAssembly.instantiate(bytes, importObject)
).then(results =&gt; {
  results.instance.exports.exported_func();
});</pre>

<h3 id="Viewing_wasm_in_developer_tools">Viewing wasm in developer tools</h3>

<p>In Firefox 54+, the Developer Tool Debugger Panel has functionality to expose the text representation of any wasm code included in a web page. To view it, you can go to the Debugger Panel and click on the “wasm://” entry.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/15823/wasm-debug.png" style="display: block; height: 317px; margin: 0px auto; width: 1019px;"></p>

<p>In addition to viewing WebAssembly as text, developers are able to debug (place breakpoints, inspect the callstack, single-step, etc.) WebAssembly using the text format. See <a href="https://www.youtube.com/watch?v=R1WtBkMeGds">WebAssembly debugging with Firefox DevTools</a> for a video preview.</p>

<h2 id="Memory">Memory</h2>

<p>In the low-level memory model of WebAssembly, memory is represented as a contiguous range of untyped bytes called <a href="https://webassembly.org/docs/semantics/#linear-memory">Linear Memory</a> that are read and written by <a href="https://webassembly.org/docs/semantics/#linear-memory-accesses">load and store instructions</a> inside the module.  In this memory model, any load or store can access any byte in the entire linear memory, which is necessary to faithfully represent C/C++ concepts like pointers.</p>

<p>Unlike a native C/C++ program, however, where the available memory range spans the entire process, the memory accessible by a particular WebAssembly Instance is confined to one specific — potentially very small — range contained by a WebAssembly Memory object.  This allows a single web app to use multiple independent libraries — each of which are using WebAssembly internally — to have separate memories that are fully isolated from each other. In addition, newer implementations can also create <a href="/en-US/docs/WebAssembly/Understanding_the_text_format#Shared_memories">shared memories</a>, which can be transferred between Window and Worker contexts using <code><a href="/en-US/docs/Web/API/Window/postMessage">postMessage()</a></code>, and used in multiple places.</p>

<p>In JavaScript, a Memory instance can be thought of as a resizable <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a></code> (or <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/SharedArrayBuffer">SharedArrayBuffer</a></code>, in the case of shared memories) and, just as with <code>ArrayBuffers</code>, a single web app can create many independent Memory objects.  You can create one using the {{jsxref("WebAssembly.Memory()")}} constructor, which takes as arguments an initial size and (optionally) a maximum size and a <code>shared</code> property that states whether it is a shared memory or not.</p>

<p>Let’s start exploring this by looking at a quick example.</p>

<ol>
 <li>
  <p>Create another new simple HTML page (copy our <a href="https://github.com/mdn/webassembly-examples/blob/master/template/template.html">simple template</a>) and call it <code>memory.html</code>. Add a <code>&lt;script&gt;&lt;/script&gt;</code> element to the page.</p>
 </li>
 <li>
  <p>Now add the following line to the top of your script, to create a memory instance:</p>

  <pre class="brush: js notranslate">var memory = new WebAssembly.Memory({initial:10, maximum:100});</pre>

  <p>The unit of <code>initial</code> and <code>maximum</code> is WebAssembly pages — these are fixed to 64KB in size. This means that the above memory instance has an initial size of 640KB, and a maximum size of 6.4MB.</p>

  <p>WebAssembly memory exposes its bytes by providing a buffer getter/setter that returns an ArrayBuffer. For example, to write 42 directly into the first word of linear memory, you can do this:</p>

  <pre class="brush: js notranslate">new Uint32Array(memory.buffer)[0] = 42;</pre>

  <p>You can then return the same value using:</p>

  <pre class="brush: js notranslate">new Uint32Array(memory.buffer)[0]</pre>
 </li>
 <li>
  <p>Try this now in your demo — save what you’ve added so far, load it in your browser, then try entering the above two lines in your JavaScript console.</p>
 </li>
</ol>

<h3 id="Growing_memory">Growing memory</h3>

<p>A memory instance can be grown by calls to {{jsxref("Memory.prototype.grow()")}}, where again the argument is specified in units of WebAssembly pages:</p>

<pre class="brush: js notranslate">memory.grow(1);</pre>

<p>If a maximum value was supplied upon creation of the memory instance, attempts to grow past this maximum will throw a {{jsxref("WebAssembly.RangeError")}} exception. The engine takes advantage of this supplied upper-bounds to reserve memory ahead of time, which can make resizing more efficient.</p>

<p>Note: Since an {{domxref("ArrayBuffer")}}’s byteLength is immutable, after a successful {{jsxref("Memory.prototype.grow()")}} operation the buffer getter will return a new ArrayBuffer object (with the new byteLength) and any previous ArrayBuffer objects become “detached”, or disconnected from the underlying memory they previously pointed to.</p>

<p>Just like functions, linear memories can be defined inside a module or imported. Similarly, a module may also optionally export its memory. This means that JavaScript can get access to the memory of a WebAssembly instance either by creating a new <code>WebAssembly.Memory</code> and passing it in as an import or by receiving a Memory export (via <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Instance/exports">Instance.prototype.exports</a></code>).</p>

<h3 id="More_involved_memory_example">More involved memory example</h3>

<p>Let’s make the above assertions clearer by looking at a more involved memory example — a WebAssembly module that imports the memory instance we defined earlier, populates it with an array of integers, then sums them. You can find this at <a href="https://github.com/mdn/webassembly-examples/raw/master/js-api-examples/memory.wasm">memory.wasm.</a></p>

<ol>
 <li>
  <p>make a local copy of <code>memory.wasm</code> in the same directory as before.</p>

  <div class="note">
  <p><strong>Note</strong>: You can see the module’s text representation at <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/memory.wat">memory.wat</a>.</p>
  </div>
 </li>
 <li>
  <p>Go back to your <code>memory.html</code> sample file, and fetch, compile, and instantiate your wasm module as before — add the following to the bottom of your script:</p>

  <pre class="brush: js notranslate">WebAssembly.instantiateStreaming(fetch('memory.wasm'), { js: { mem: memory } })
.then(results =&gt; {
  // add code here
});</pre>
 </li>
 <li>
  <p>Since this module exports its memory, given an Instance of this module called instance we can use an exported function <code>accumulate()</code> to create and populate an input array directly in the module instance’s linear memory (<code>mem</code>). Add the following into your code, where indicated:</p>

  <pre class="brush: js notranslate">var i32 = new Uint32Array(memory.buffer);

for (var i = 0; i &lt; 10; i++) {
  i32[i] = i;
}

var sum = results.instance.exports.accumulate(0, 10);
console.log(sum);</pre>
 </li>
</ol>

<p>Note how we create the {{domxref("Uint32Array")}} view on the Memory object’s buffer (<code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Memory/buffer">Memory.prototype.buffer</a></code>), not on the Memory itself.</p>

<p>Memory imports work just like function imports, only Memory objects are passed as values instead of JavaScript functions. Memory imports are useful for two reasons:</p>

<ul>
 <li>They allow JavaScript to fetch and create the initial contents of memory before or concurrently with module compilation.</li>
 <li>They allow a single Memory object to be imported by multiple module instances, which is a critical building block for implementing dynamic linking in WebAssembly.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: You can find our complete demo at <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/memory.html">memory.html</a> (<a href="https://mdn.github.io/webassembly-examples/js-api-examples/memory.html">see it live also</a>) .</p>
</div>

<h2 id="Tables">Tables</h2>

<p>A WebAssembly Table is a resizable typed array of <a href="https://en.wikipedia.org/wiki/Reference_(computer_science)">references</a> that can be accessed by both JavaScript and WebAssembly code.  While Memory provides a resizable typed array of raw bytes, it is unsafe for references to be stored in a Memory since a reference is an engine-trusted value whose bytes must not be read or written directly by content for safety, portability, and stability reasons.</p>

<p>Tables have an element type, which limits the types of reference that can be stored in the table.  In the current iteration of WebAssembly, there is only one type of reference needed by WebAssembly code — functions — and thus only one valid element type.  In future iterations, more element types will be added.</p>

<p>Function references are necessary to compile languages like C/C++ that have function pointers.  In a native implementation of C/C++, a function pointer is represented by the raw address of the function’s code in the process’s virtual address space and so, for the safety reasons mentioned above, cannot be stored directly in linear memory.  Instead, function references are stored in a table and their indexes, which are integers and can be stored in linear memory, are passed around instead.</p>

<p>When the time comes to call a function pointer, the WebAssembly caller supplies the index, which can then be safety bounds checked against the table before indexing and calling the indexed function reference.  Thus, tables are currently a rather low-level primitive used to compile low-level programming language features safely and portably.</p>

<p>Tables can be mutated via <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Table/set">Table.prototype.set()</a></code>, which updates one of the values in a table, and <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Table/grow">Table.prototype.grow()</a></code>, which increases the number of values that can be stored in a table.  This allows the indirectly-callable set of functions to change over time, which is necessary for <a href="https://webassembly.org/docs/dynamic-linking/">dynamic linking techniques</a>.  The mutations are immediately accessible via <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Table/get">Table.prototype.get()</a></code> in JavaScript, and to wasm modules.</p>

<h3 id="A_table_example">A table example</h3>

<p>Let’s look at a simple table example — a WebAssembly module that creates and exports a table with two elements: element 0 returns 13 and element 1 returns 42. You can find this at <a href="https://github.com/mdn/webassembly-examples/raw/master/js-api-examples/table.wasm">table.wasm</a>.</p>

<ol>
 <li>
  <p>Make a local copy of <code>table.wasm</code> in a new directory.</p>

  <div class="note">
  <p><strong>Note</strong>: You can see the module’s text representation at <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/table.wat">table.wat</a>.</p>
  </div>
 </li>
 <li>
  <p>Create a new copy of our <a href="https://github.com/mdn/webassembly-examples/blob/master/template/template.html">HTML template</a> in the same directory and call it <code>table.html</code>.</p>
 </li>
 <li>
  <p>As before, fetch, compile, and instantiate your wasm module — add the following into a {{htmlelement("script")}} element at the bottom of your HTML body:</p>

  <pre class="brush: js notranslate">WebAssembly.instantiateStreaming(fetch('table.wasm'))
.then(function(results) {
  // add code here
});</pre>
 </li>
 <li>
  <p>Now let’s access the data in the tables — add the following lines to your code in the indicated place:</p>

  <pre class="brush: js notranslate">var tbl = results.instance.exports.tbl;
console.log(tbl.get(0)());  // 13
console.log(tbl.get(1)());  // 42</pre>
 </li>
</ol>

<p>This code accesses each function reference stored in the table in turn, and instantiates them to print the values they hold to the console — note how each function reference is retrieved with a <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Table/get">Table.prototype.get()</a></code> call, then we add an extra set of parentheses on the end to actually invoke the function.</p>

<div class="note">
<p><strong>Note</strong>: You can find our complete demo at <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/table.html">table.html</a> (<a href="https://mdn.github.io/webassembly-examples/js-api-examples/table.html">see it live also</a>).</p>
</div>

<h2 id="Globals">Globals</h2>

<p>WebAssembly has the ability to create global variable instances, accessible from both JavaScript and importable/exportable across one or more {{jsxref("WebAssembly.Module")}} instances. This is very useful, as it allows dynamic linking of multiple modules.</p>

<p>To create a WebAssembly global instance from inside your JavaScript, you use the {{jsxref("WebAssembly.Global()")}} constructor, which looks like this:</p>

<pre class="brush: js notranslate">const global = new WebAssembly.Global({value:'i32', mutable:true}, 0);</pre>

<p>You can see that this takes two parameters:</p>

<ul>
 <li>An object that contains two properties describing the global variable:
  <ul>
   <li><code>value</code>: its data type, which can be any data type accepted within WebAssembly modules — <code>i32</code>, <code>i64</code>, <code>f32</code>, or <code>f64</code>.</li>
   <li><code>mutable</code>: a boolean defining whether the value is mutable or not.</li>
  </ul>
 </li>
 <li>A value containing the variable's actual value. This can be any value, as long as its type matches the specified data type.</li>
</ul>

<p>So how do we use this? In the following example we define a global as a mutable <code>i32</code> type, with a value of 0.</p>

<p>The value of the global is then changed, first to <code>42</code> using the <code>Global.value</code> property, and then to 43 using the <code>incGlobal()</code> function exported out of the <code>global.wasm</code> module (this adds 1 to whatever value is given to it and then returns the new value).</p>

<pre class="brush: js notranslate">const output = document.getElementById('output');

function assertEq(msg, got, expected) {
    output.innerHTML += `Testing ${msg}: `;
    if (got !== expected)
        output.innerHTML += `FAIL!&lt;br&gt;Got: ${got}&lt;br&gt;Expected: ${expected}&lt;br&gt;`;
    else
        output.innerHTML += `SUCCESS! Got: ${got}&lt;br&gt;`;
}

assertEq("WebAssembly.Global exists", typeof WebAssembly.Global, "function");

const global = new WebAssembly.Global({value:'i32', mutable:true}, 0);

WebAssembly.instantiateStreaming(fetch('global.wasm'), { js: { global } })
.then(({instance}) =&gt; {
    assertEq("getting initial value from wasm", instance.exports.getGlobal(), 0);
    global.value = 42;
    assertEq("getting JS-updated value from wasm", instance.exports.getGlobal(), 42);
    instance.exports.incGlobal();
    assertEq("getting wasm-updated value from JS", global.value, 43);
});</pre>

<div class="note">
<p><strong>Note</strong>: You can see the example <a href="https://mdn.github.io/webassembly-examples/js-api-examples/global.html">running live on GitHub</a>; see also the <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/global.html">source code</a>.</p>
</div>

<h2 id="Multiplicity">Multiplicity</h2>

<p>Now we’ve demonstrated usage of the main key WebAssembly building blocks, this is a good place to mention the concept of multiplicity. This provides WebAssembly with a multitude of advances in terms of architectural efficiency:</p>

<ul>
 <li>One module can have N Instances, in the same way that one function literal can produce N closure values.</li>
 <li>One module instance can use 0–1 memory instances, which provide the "address space" of the instance. Future versions of WebAssembly may allow 0–N memory instances per module instance (see <a href="https://webassembly.org/docs/future-features/#multiple-tables-and-memories">Multiple Tables and Memories</a>).</li>
 <li>One module instance can use 0–1 table instances — this is the "function address space" of the instance, used to implement C function pointers. Future versions of WebAssembly may allow 0–N table instances per module instance.</li>
 <li>One memory or table instance can be used by 0–N module instances — these instances all share the same address space, allowing <a href="https://webassembly.org/docs/dynamic-linking">dynamic linking</a>.</li>
</ul>

<p>You can see multiplicity in action in our Understanding text format article — see the <a href="/en-US/docs/WebAssembly/Understanding_the_text_format#Mutating_tables_and_dynamic_linking">Mutating tables and dynamic linking section</a>.</p>

<h2 id="Summary">Summary</h2>

<p>This article has taken you through the basics of using the WebAssembly JavaScript API to include a WebAssembly module in a JavaScript context and make use of its functions, and how to use WebAssembly memory and tables in JavaScript. We also touched on the concept of multiplicity.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://webassembly.org/">webassembly.org</a></li>
 <li><a href="/en-US/docs/WebAssembly/Concepts">WebAssembly concepts</a></li>
 <li><a href="https://research.mozilla.org/webassembly/">WebAssembly on Mozilla Research</a></li>
</ul>
